import java.util.ArrayList;

public class Pion extends Piece {

    Pion(String couleur) {
        super(couleur);
    }

    /*
    Dans cette méthode on fait le déplacement du pion.
     */
    @Override
    public ArrayList<Case> getDepPossibles(Echiquier ech) {
        ArrayList<Case> array = new ArrayList<Case>();

        int col = this.getC();

        /*
        Si le pion est noir,
         */
        if (this.getCoul().equals(Piece.NOIR)) {
            /*
            il commence en haut de l'échiquier.
             */
            if (this.getL() == 1) {
                /*
                Boucle pour le déplacement du pion, si il n'a pas encore bougé,
                il peut se deplacer de 2 cases vers l'avant.
                 */
                for (int lig = getL(); lig < getL() + 3; lig++) {

                    if ((lig != this.getL() || col != this.getC()
                            && ech.caseExiste(lig, col))
                            && null == ech.getPiece(lig, col)) {

                        array.add(new Case(lig, col));
                    }
                }
            } else {
                for (int lig = getL(); lig < getL() + 2; lig++) {

                    if ((lig != this.getL() || col != this.getC()
                            && ech.caseExiste(lig, col))
                            && null == ech.getPiece(lig, col)) {

                        array.add(new Case(lig, col));
                    }

                }
            }
            /* Déplacement en diagonale droite pour le pion Noir*/
            /* Si la case existe, que la case n'est pas null et qu'elle ne contient pas de piece noire, alors le déplacement est possible*/
            if (ech.caseExiste(this.getL()+1, col + 1)
                    && null != ech.getPiece(this.getL()+1, col + 1)
                    && !ech.getPiece(this.getL()+1, col+1).getCoul().equals(this.getCoul())) {
                array.add(new Case(this.getL()+1, col+1));
            }
            /* Déplacement en diagonale gauche pour le pion Noir*/
            if (ech.caseExiste(this.getL()+1, col -1)
                    && null != ech.getPiece(this.getL()+1, col -1)
                    && !ech.getPiece(this.getL()+1, col-1).getCoul().equals(this.getCoul())) {
                array.add(new Case(this.getL()+1, col-1));
            }
        }
        /*
        Sinon, si le pion est blanc,
         */
        if (this.getCoul().equals(Piece.BLANC)) {
            /*
            il commence en bas de l'échiquier
             */
            if (this.getL() == 6) {
                /*
                Boucle pour le déplacement du pion, si il n'a pas encore bougé,
                il peut se deplacer de 2 cases vers l'avant.
                 */
                for (int lig = getL(); lig > getL() - 3; lig--) {
                    if ((lig != this.getL()
                            || col != this.getC()
                            && ech.caseExiste(lig, col))
                            && null == ech.getPiece(lig, col)) {
                        array.add(new Case(lig, col));
                    }
                }
            } else {
                for (int lig = getL(); lig > getL() - 2; lig--) {
                    if ((lig != this.getL() || col != this.getC()
                            && ech.caseExiste(lig, col))
                            && null == ech.getPiece(lig, col)) {
                        array.add(new Case(lig, col));
                    }

                }
                /* Déplacement en diagonale droite pour le pion Blanc*/
                if (ech.caseExiste(this.getL()-1, col + 1)
                        && null != ech.getPiece(this.getL()-1, col + 1)
                        && !ech.getPiece(this.getL()-1, col+1).getCoul().equals(this.getCoul())) {
                    array.add(new Case(this.getL()-1, col+1));
                }
                /* Déplacement en diagonale  pour le pion Blanc*/
                if (ech.caseExiste(this.getL()-1, col -1)
                        && null != ech.getPiece(this.getL()-1, col -1)
                        && !ech.getPiece(this.getL()-1, col-1).getCoul().equals(this.getCoul())) {
                    array.add(new Case(this.getL()-1, col-1));
                }

            }
        }
        return array;
    }

    /*
	Méthode toString pour afficher la couleur de la piece
	 */
    @Override
    public String toString() {
        if(this.getCoul().equals("B")){
            return "PB";
        }
        else{
            return "PN";
        }
    }

}